#####################################################################################################
#Program:log_manager.pm																				#
#Comment:																							#
#	ǽlogѥץॵ֥롼ʥե˽񤭹ߤԤޤ						#
#	errorSub(logե, ȯ, submiterrorʤɤ, ٤, $option)			#
#																									#
#$option-+->{exit}   = exit (̤1)															#
#        |																							#
#        +->{return} = return (ꤹexitʤ)												#
#        |																							#
#        +->{file}   = "no" (noȻꤹlogϤʤ.⤷ϥեΥѥϡ				#
#        |					̤Ǥ~HOME/logs/script.log˽Ϥޤ							#
#        |																							#
#																									#
#																									#
#   Date:	20050306																				#
# Update:	20050306																				#
#Version:	1.1																						#
# Author:	Gigaho																					#
#####################################################################################################
# use strict;

###################################################
#  input:()
# retrun:
#comment:
#顼֥롼new˶
###################################################
sub write_log
{
	my ($place, $type, $comment, $ropt) = @_;
	
	my $date     = get_date();
	my $ip       = $ENV{"REMOTE_ADDR"};
	my $client   = $ENV{"HTTP_USER_AGENT"};

	my $log_file = $ropt->{"file"};
	my $out_str  = "$date|$ip|$client|$place|$type|$comment\n";
	if($log_file ne "no") {
		if(!defined($log_file)) {$log_file = "default.cgi";}
		open(LOG,">>$log_file")
			|| die "$log_file Log open error $!\n";
		print LOG $out_str;
		close(LOG)
			|| die "$log_file Log close error $!\n";
		if($ropt->{"print"}){print $out_str;}
	}
	
	my $ret_num = $ropt->{return};
	if(!defined($ret_num)){
		my $exit_num = $ropt->{exit};
		if(defined($exit_num)){exit $exit_num;}
		exit 1;
	}
	
	return $ret_num; 
}


###################################################
#  input:()
# retrun:
#comment:
#դ
###################################################
sub get_date
{
	my $date;
	chop($date = `date`);
	chomp $date;
	$date =~ s/JST//g;
	return $date;
}


###################################################
#  input:()
# retrun:
#comment:
#顼ɽHTML
###################################################
sub error_htm
{
	my ($pname, $line, $type, $comment, $ropt) = @_;
	write_log("$pname($line)", $type, $comment, {
		file   => $ropt->{file},
		return => 1
	});
	
	my $logo = $ropt->{logo};
	my $back = $ropt->{back};
	if(!defined($back)){$back = "javascript:history.back();"}
	my $reflesh = ($ropt->{reflesh})?
		qq{<META HTTP-EQUIV="REFRESH" CONTENT="2;URL=$ropt->{reflesh}">}:"";
	
	print("Content-type: text/html\n\n");
	print qq{<HTML>
		<HEAD>
		<META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=EUC-JP'>
		$reflesh
			<TITLE>$type</TITLE>
		</HEAD>
		<BODY BGCOLOR='#FFFFFF'>
		<BR>
		<CENTER><H1><FONT COLOR='red'>$type</FONT></H1><BR>
			<H2>$ropt->{v}</H2>
		</CENTER>
		<HR ALIGN='CENTER' WIDTH='100%'>
		<A HREF='$back'>BACK</A><BR>
	};
	
	if(defined($logo)){
		print("<IMG SRC=$logo WIDTH='220' HEIGHT='30' ALIGN='right' BORDER='0'>\n");
	}

	print("</BODY></HTML>\n");
	
	exit 1;
}


###################################################
#  input:()
# retrun:
#comment:
###################################################
sub param
{
	my (%param, $buffer);
	
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		if ($ENV{'CONTENT_LENGTH'} > 51200) { die "̤礭ޤ"; }
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else { $buffer = $ENV{'QUERY_STRING'}; }
	my @pairs = split(/&/, $buffer);
	foreach (@pairs) {
		my ($name, $value) = split(/=/, $_);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		$param{$name} = $value;
		$FORM{$name} = $value;
	}
	
	return \%param;
}

1;

